texture TexMap;
sampler TexMapSamp = sampler_state
{
    Texture = <TexMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;

   AddressU = Clamp;
   AddressV = Clamp;
};

texture TexMap2;
sampler TexMapSamp2 = sampler_state
{
    Texture = <TexMap2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;

   AddressU = Clamp;
   AddressV = Clamp;
};

// WVF[_
struct VS_OUTPUT_BlurShader
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
	float4 PosTex		: TEXCOORD1;
};

VS_OUTPUT_BlurShader VS_BlurShader(
      float4 Pos    : POSITION,
      float2 Tex    : TEXCOORD0 )
{
	VS_OUTPUT_BlurShader Out = (VS_OUTPUT_BlurShader)0;
	Out.Pos = Pos;
	
	Out.Tex = Tex;
	Out.PosTex = Pos;
	
	return Out;
}

float4 PS_BlurShader( VS_OUTPUT_BlurShader In ) : COLOR0
{
	float4 Col = 0;
	for( int i = 0; i < 16; ++i ){
		Col += tex2D( TexMapSamp, In.Tex + float2( In.PosTex.x / 100 * i, -In.PosTex.y / 100 * i ) );
	}
	return Col / 16;
}

technique BlurShader{
	pass P0{
		VertexShader = compile vs_2_0 VS_BlurShader();
		PixelShader  = compile ps_2_0 PS_BlurShader();
	}
}

// RippleVF[_
struct VS_OUTPUT_RippleShader
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT_RippleShader VS_RippleShader(
      float4 Pos    : POSITION,
      float2 Tex    : TEXCOORD0 )
{
	VS_OUTPUT_RippleShader Out = (VS_OUTPUT_RippleShader)0;
	Out.Pos = Pos;
	
	Out.Tex = Tex;
	
	return Out;
}

float4 PS_RippleShader( VS_OUTPUT_RippleShader In ) : COLOR0
{
	return tex2D( TexMapSamp, In.Tex + ( tex2D( TexMapSamp2, In.Tex ).bg - 0.5 ) / 20 );
}

technique RippleShader{
	pass P0{
		VertexShader = compile vs_2_0 VS_RippleShader();
		PixelShader  = compile ps_2_0 PS_RippleShader();
	}
}
